package dk.rsd.dcc;

import dk.rsd.dcc.configuration.IntegrationTestConfiguration;
import org.apache.http.StatusLine;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import static org.junit.Assert.assertEquals;

@RunWith(SpringRunner.class)
@ContextConfiguration(classes = { IntegrationTestConfiguration.class})
public class ReloadConfigurationServletIntegrationsTest {
    @Value("${dcc.host}")
    private String dccHost;

    @Test
    public void givenRequestThenResponseShouldBe200() throws URISyntaxException, IOException {
        URI uri = new URI(dccHost + "/decoupling/reloadConfiguration/start");
        assertEquals(200, httpGet(uri).getStatusCode());
    }

    @Test
    public void givenRequestToStatusThenResponseShouldBe200() throws URISyntaxException, IOException {
        URI uri = new URI(dccHost + "/decoupling/reloadConfiguration/status");
        assertEquals(200, httpGet(uri).getStatusCode());
    }

    public static StatusLine httpGet(URI uri) throws IOException {
        try (CloseableHttpClient c = HttpClients.createMinimal()) {
            try (CloseableHttpResponse res = c.execute(new HttpGet(uri))) { return res.getStatusLine(); }
        }
    }
}