package dk.rsd.dcc.configuration;

import dk.rsd.dcc.util.DccNTSServicePortFactory;
import dk.sundhedsdatastyrelsen.dcc.wsdl.DccNTSServicePort;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.*;

import java.util.Optional;


@Configuration
@ImportResource({ "classpath:META-INF/cxf/cxf.xml"})
@PropertySource("${env:dev}.properties")
public class IntegrationTestConfiguration {

    @Value("${dcc.host}")
    String dccHost;

    @Bean
    @Primary
    public DccNTSServicePort dccNTSServicePort() {
        return DccNTSServicePortFactory.buildDccNTSServicePort(dccHost, "http://nspop.dk/nts/2013/05#invoke", Optional.empty());
    }

    @Bean(name = "3Millisec")
    public DccNTSServicePort dccNTS3MillisecServicePort() {
        return DccNTSServicePortFactory.buildDccNTSServicePort(dccHost, "http://nspop.dk/nts/2013/05#invoke3millisec", Optional.empty());
    }

    @Bean(name = "sosigateway")
    public DccNTSServicePort dccNTSSosigw() {
        return DccNTSServicePortFactory.buildDccNTSServicePort(dccHost, "http://nspop.dk/nts/2013/05#verify", Optional.empty());
    }
}
