/*
 * SOSI-DCC - Copyright (C) 2011 National Board of e-Health (NSI)
 *
 * All source code and information supplied as part of SOSI-DCC is
 * copyright to its contributers.
 *
 * The source code has been released under a dual license - meaning you can
 * use either licensed version of the library with your code.
 *
 * It is released under the Common Public License 1.0, a copy of which can
 * be found at the link below.
 * http://www.opensource.org/licenses/cpl1.0.php
 *
 * It is released under the LGPL (GNU Lesser General Public License), either
 * version 2.1 of the License, or (at your option) any later version. A copy
 * of which can be found at the link below.
 * http://www.gnu.org/copyleft/lesser.html
 *
 * $HeadURL: https://svn.nspop.dk/svn/lakeside/sosi-dcc/tags/release-2.4.3/modules/client-dcc-websphere/src/test/java/dk/rsd/dcc/client/WebsphereMQHelper.java $
 * $Id: WebsphereMQHelper.java 33 2017-01-12 16:52:05Z chg $
 */
package dk.rsd.dcc.client;

import javax.jms.JMSException;
import javax.jms.QueueConnection;

import com.ibm.mq.jms.JMSC;
import com.ibm.mq.jms.MQQueueConnectionFactory;

import dk.rsd.dcc.client.JMSHelper;

public class WebsphereMQHelper implements JMSHelper {

	private String mqHostname = System.getProperty("dcc.mq_host", "gasser");
	private String queueManager = System.getProperty("dcc.mq_queuemanager", "QM_gasser");
	private String channel = System.getProperty("dcc.mq_channel", "S_gasser");
	private int port = Integer.getInteger("dcc.mq_port", 1414);

	public QueueConnection getQueueConnection() throws JMSException {
		MQQueueConnectionFactory factory = new MQQueueConnectionFactory();
		factory.setHostName(mqHostname);
		factory.setQueueManager(queueManager);
		factory.setChannel(channel);
		factory.setPort(port);
		factory.setTransportType(JMSC.MQJMS_TP_CLIENT_MQ_TCPIP);
		return factory.createQueueConnection();
	}

}
