@echo off
setlocal

rem Read configuration file if specified as parameter
if [%1] NEQ [] (
    echo Getting configuration from %1
    call %1
)

rem Set default values
if "%DCC_JBOSS_HOME%" == "" set DCC_JBOSS_HOME=c:\jboss-4.2.3.GA
if "%DCC_JBOSS_PORT%" == "" set DCC_JBOSS_PORT=8080
if "%DCC_JBOSS_NAMING_PORT%" == "" set DCC_JBOSS_NAMING_PORT=1099
if "%DCC_CLOVER_HISTORY_DIR%" == "" set DCC_CLOVER_HISTORY_DIR=clover_history

echo ----------------------------------------------------
echo DCC_JBOSS_HOME: %DCC_JBOSS_HOME%
echo DCC_JBOSS_PORT: %DCC_JBOSS_PORT%
echo DCC_JBOSS_NAMING_PORT: %DCC_JBOSS_NAMING_PORT%
echo DCC_CLOVER_HISTORY_DIR: %DCC_CLOVER_HISTORY_DIR%
echo ----------------------------------------------------

set DCC_ENDPOINT=http://localhost:%DCC_JBOSS_PORT%/decoupling-clover/

set NOPAUSE=TRUE

rem Ensure that there is no sosi-dcc instance deployed
del %DCC_JBOSS_HOME%\server\default\deploy\decoupling*.war

rem Start JBoss
start /b "JBoss" %DCC_JBOSS_HOME%\bin\run.bat ^> jboss.log

rem Build an instrumented sosi-dcc instance
cmd /c mvn clean clover2:instrument

rem Deploy the instrumented sosi-dcc instance
copy target\clover\decoupling-clover.war %DCC_JBOSS_HOME%\server\default\deploy\

rem Measure test coverage
cmd /c mvn clover2:setup test clover2:aggregate clover2:clover -P coverage -Ddcc.endpoint=%DCC_ENDPOINT% -Ddcc.jboss_naming_port=%DCC_JBOSS_NAMING_PORT%

rem Undeploy the instrumented sosi-dcc instance
del %DCC_JBOSS_HOME%\server\default\deploy\decoupling-clover.war

rem Stop JBoss
start /b "Shutdown JBoss" %DCC_JBOSS_HOME%\bin\shutdown.bat -s jnp://localhost:%DCC_JBOSS_NAMING_PORT%

rem Verify that the test coverage target is reached
cmd /c mvn clover2:check clover2:save-history -Dclover.history.dir=%DCC_CLOVER_HISTORY_DIR%

exit /b %errorlevel%
