/*
 * SOSI-DCC - Copyright (C) 2011 National Board of e-Health (NSI)
 *
 * All source code and information supplied as part of SOSI-DCC is
 * copyright to National Board of e-Health.
 *
 * The source code has been released under a dual license - meaning you can
 * use either licensed version of the library with your code.
 *
 * It is released under the Common Public License 1.0, a copy of which can
 * be found at the link below.
 * http://www.opensource.org/licenses/cpl1.0.php
 *
 * It is released under the LGPL (GNU Lesser General Public License), either
 * version 2.1 of the License, or (at your option) any later version. A copy
 * of which can be found at the link below.
 * http://www.gnu.org/copyleft/lesser.html
 *
 * $HeadURL: https://svn.nspop.dk/svn/lakeside/sosi-dcc/tags/release-2.4.3/modules/dcc/src/main/java/dk/rsd/dcc/dispatch/CommonResourceLocator.java $
 * $Id: CommonResourceLocator.java 33 2017-01-12 16:52:05Z chg $
 */
package dk.rsd.dcc.dispatch;

import commonj.timers.TimerManager;
import commonj.work.WorkManager;
import org.apache.log4j.Logger;

import javax.naming.InitialContext;
import javax.naming.NamingException;

public class CommonResourceLocator {

	private static final Logger log = Logger.getLogger(CommonResourceLocator.class);

	private static WorkManager workManager;
	private static TimerManager timerManager;

	public static WorkManager getWorkManager() {
		if (workManager == null) {
			try {
				InitialContext ctx = new InitialContext();
				String jndiName = "java:comp/env/wm/DccWorkManager";
				workManager = (WorkManager) ctx.lookup(jndiName);
				log.info("WorkManager obtained");
			} catch (NamingException e) {
				log.error("Unable to lookup workmanager: ", e);
			}
		}
		return workManager;
	}

	public static TimerManager getTimerManager() {
		if (timerManager == null) {
			try {
				InitialContext ctx = new InitialContext();
				String jndiName = "java:comp/env/tm/DccTimerManager";
				timerManager = (TimerManager) ctx.lookup(jndiName);
				log.info("TimerManager obtained");
			} catch (NamingException e) {
				log.error("Unable to lookup timermanager: ", e);
			}
		}
		return timerManager;
	}

}
