/*
 * SOSI-DCC - Copyright (C) 2011 National Board of e-Health (NSI)
 *
 * All source code and information supplied as part of SOSI-DCC is
 * copyright to National Board of e-Health.
 *
 * The source code has been released under a dual license - meaning you can
 * use either licensed version of the library with your code.
 *
 * It is released under the Common Public License 1.0, a copy of which can
 * be found at the link below.
 * http://www.opensource.org/licenses/cpl1.0.php
 *
 * It is released under the LGPL (GNU Lesser General Public License), either
 * version 2.1 of the License, or (at your option) any later version. A copy
 * of which can be found at the link below.
 * http://www.gnu.org/copyleft/lesser.html
 *
 * $HeadURL: https://svn.nspop.dk/svn/lakeside/sosi-dcc/tags/release-2.4.3/modules/dcc/src/main/java/dk/rsd/dcc/fault/DccFault.java $
 * $Id: DccFault.java 33 2017-01-12 16:52:05Z chg $
 */
package dk.rsd.dcc.fault;

public abstract class DccFault extends Exception {

	public static final String TIMEOUT = "dcc_timeout";
	public static final String SYNTAX_ERROR = "dcc_syntax_error";
	public static final String GENERAL_ERROR = "dcc_general_error";
	public static final String ACCESS_DENIED = "dcc_access_denied";

	private final String faultCode;

	public DccFault(String faultCode, String msg) {
		super(msg);
		this.faultCode = faultCode;
	}

	public DccFault(String faultCode, String msg, Exception e) {
		super(msg + ": " + e.getMessage());
		this.faultCode = faultCode;
	}

	public DccFault(String faultCode, Exception e) {
		super(e);
		this.faultCode = faultCode;
	}

	public String getFaultCode() {
		return faultCode;
	}
}
