/*
 *
 *  * The MIT License
 *  *
 *  * Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
 *  *
 *  * Copyright (C) 2014 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
 *  *
 *  * Permission is hereby granted, free of charge, to any person obtaining a copy of
 *  * this software and associated documentation files (the "Software"), to deal in
 *  * the Software without restriction, including without limitation the rights to
 *  * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
 *  * of the Software, and to permit persons to whom the Software is furnished to do
 *  * so, subject to the following conditions:
 *  *
 *  * The above copyright notice and this permission notice shall be included in all
 *  * copies or substantial portions of the Software.
 *  *
 *  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  * SOFTWARE.
 *  *
 *  * $HeadURL: https://svn.nspop.dk/svn/lakeside/sosi-dcc/tags/release-2.4.3/modules/dcc/src/main/java/dk/rsd/dcc/routing/Route.java $
 *  * $Id: Route.java 33 2017-01-12 16:52:05Z chg $
 *
 */

package dk.rsd.dcc.routing;

import dk.rsd.dcc.DecouplingInfo;

import java.net.URL;

public class Route {
    private String soapAction;
    private String serviceIdentifier;
    private URL serviceURL;
    private URL proxyURL;
    private DecouplingInfo decouplingInfo;
    private int idCardMaxAge = -1;
    private boolean doNotVerifySSLHostname = false;
    private WSAHeaderProcessing wsaHeaderProcessing;

    public String getSoapAction() {
        return soapAction;
    }

    public void setSoapAction(String soapAction) {
        this.soapAction = soapAction;
    }

    public String getServiceIdentifier() {
        return serviceIdentifier;
    }

    public void setServiceIdentifier(String serviceIdentifier) {
        this.serviceIdentifier = serviceIdentifier;
    }

    public URL getServiceURL() {
        return serviceURL;
    }

    public void setServiceURL(URL serviceURL) {
        this.serviceURL = serviceURL;
    }

    public URL getProxyURL() {
        return proxyURL;
    }

    public void setProxyURL(URL proxyURL) {
        this.proxyURL = proxyURL;
    }

    public DecouplingInfo getDecouplingInfo() {
        return decouplingInfo;
    }

    public void setDecouplingInfo(DecouplingInfo decouplingInfo) {
        this.decouplingInfo = decouplingInfo;
    }

    public int getIdCardMaxAge() {
        return idCardMaxAge;
    }

    public void setIdCardMaxAge(int idCardMaxAge) {
        this.idCardMaxAge = idCardMaxAge;
    }

    public boolean doNotVerifySSLHostname() {
        return doNotVerifySSLHostname;
    }

    public void setDoNotVerifySSLHostname(boolean doNotVerifySSLHostname) {
        this.doNotVerifySSLHostname = doNotVerifySSLHostname;
    }

    public WSAHeaderProcessing getWSAHeaderProcessing() {
        // always set WSA when calling throug SOSI-GW
        if (proxyURL != null ) {
            return WSAHeaderProcessing.WSA_OVERWRITE;
        // default is overwriting WSA
        } else if (wsaHeaderProcessing == null) {
            return WSAHeaderProcessing.WSA_OVERWRITE;
        } else {
            return wsaHeaderProcessing;
        }
    }

    public void setWsaHeaderProcessing(WSAHeaderProcessing wsaHeaderProcessing) {
        this.wsaHeaderProcessing = wsaHeaderProcessing;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Route route = (Route) o;

        return soapAction.equals(route.soapAction);

    }

    @Override
    public int hashCode() {
        return soapAction.hashCode();
    }
}
