package dk.rsd.dcc.routing;

import java.util.Objects;

public class RouteIdentifier {
    private String soapAction;
    private String serviceIdentifier;

    public RouteIdentifier(String soapAction, String serviceIdentifier) {
        this.soapAction = soapAction;
        this.serviceIdentifier = serviceIdentifier;
    }

    public static RouteIdentifier fromRoute(Route route) {
        return new RouteIdentifier(route.getSoapAction(), route.getServiceIdentifier());
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        RouteIdentifier that = (RouteIdentifier) o;
        return Objects.equals(soapAction, that.soapAction) && Objects.equals(serviceIdentifier, that.serviceIdentifier);
    }

    @Override
    public int hashCode() {
        return Objects.hash(soapAction, serviceIdentifier);
    }
}
