package dk.sdsd.dcc.utils;

import dk.rsd.dcc.DccContext;
import dk.sdsd.nsp.slalog.api.SLALogItem;
import dk.sdsd.nsp.slalog.api.SLALogger;

public class SLALogUtil {

    private static final ThreadLocal<SLALogItem> slaLogItems = new ThreadLocal<SLALogItem>();

    private static SLALogger slaLogger;

	public static void setSLALogFromDccContext(SLALogItem slaLogItem, DccContext context) {
		if (context.getSoapAction() != null) {
			slaLogItem.setSourceSOAPAction(context.getSoapAction());
		}
		slaLogItem.setTargetEndpoint(context.getProxyURL().toString());
		slaLogItem.setMessageId(context.getMessageID());
        if (context.getServiceIdentifier() != null) {
            slaLogItem.addCallParameter("decoupling-service-identifier", context.getServiceIdentifier());
        }
		if (context.getServiceURL() != null) {
			slaLogItem.addCallParameter("decoupling-service-url", context.getServiceURL().toString());				
		}
		if (context.getProxyURL() != null) {
			slaLogItem.addCallParameter("decoupling-proxy-url", context.getProxyURL().toString());
		}
		if (context.getItSystemName() != null) {
			slaLogItem.addCallParameter("decoupling-it-systemname", context.getItSystemName());
		}
	}

    public static SLALogger getSLALogger() {
        return slaLogger;
    }

    public static void setSLALogger(SLALogger slaLogger) {
        SLALogUtil.slaLogger = slaLogger;
    }

    public static void setSLALogItem(SLALogItem slaLogItem) {
        slaLogItems.set(slaLogItem);
    }
    public static SLALogItem getSLALogItem() {
        return slaLogItems.get();
    }

}
