/*
 * SOSI-DCC - Copyright (C) 2011 National Board of e-Health (NSI)
 *
 * All source code and information supplied as part of SOSI-DCC is
 * copyright to National Board of e-Health.
 *
 * The source code has been released under a dual license - meaning you can
 * use either licensed version of the library with your code.
 *
 * It is released under the Common Public License 1.0, a copy of which can
 * be found at the link below.
 * http://www.opensource.org/licenses/cpl1.0.php
 *
 * It is released under the LGPL (GNU Lesser General Public License), either
 * version 2.1 of the License, or (at your option) any later version. A copy
 * of which can be found at the link below.
 * http://www.gnu.org/copyleft/lesser.html
 *
 * $HeadURL: https://svn.nspop.dk/svn/lakeside/sosi-dcc/tags/release-2.4.3/modules/dcc/src/test/java/dk/rsd/dcc/DecouplingValidatorTest.java $
 * $Id: DecouplingValidatorTest.java 33 2017-01-12 16:52:05Z chg $
 */
package dk.rsd.dcc;

import junit.framework.TestCase;
import dk.rsd.dcc.fault.SyntaxFault;

public class DecouplingValidatorTest extends TestCase {

	public void testEmptyInfo() throws Exception {
		try {
			DecouplingValidator.validate(null);
			fail();
		} catch (SyntaxFault e) {
			assertEquals("No decoupling info provided", e.getMessage());
		}
	}

	public void testTimeoutMissingForSynchronousModel() throws Exception {
		try {
			DecouplingInfo info = new DecouplingInfo();
			DecouplingValidator.validate(info);
			fail();
		} catch (SyntaxFault e) {
			assertEquals("Negative or unspecified decoupling timeout", e.getMessage());
		}

	}

	public void testSynchronousModelOK() throws Exception {
		DecouplingInfo info = new DecouplingInfo();
		info.setTimeout(10);
		DecouplingValidator.validate(info);
	}



}
