/*
 *
 *  * The MIT License
 *  *
 *  * Original work sponsored and donated by National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
 *  *
 *  * Copyright (C) 2015 National Board of e-Health (NSI), Denmark (http://www.nsi.dk)
 *  *
 *  * Permission is hereby granted, free of charge, to any person obtaining a copy of
 *  * this software and associated documentation files (the "Software"), to deal in
 *  * the Software without restriction, including without limitation the rights to
 *  * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
 *  * of the Software, and to permit persons to whom the Software is furnished to do
 *  * so, subject to the following conditions:
 *  *
 *  * The above copyright notice and this permission notice shall be included in all
 *  * copies or substantial portions of the Software.
 *  *
 *  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  * SOFTWARE.
 *  *
 *  * $HeadURL: https://svn.nspop.dk/svn/lakeside/sosi-dcc/tags/release-2.4.3/modules/dcc/src/test/java/dk/rsd/dcc/MockDispatcherFactory.java $
 *  * $Id: MockDispatcherFactory.java 33 2017-01-12 16:52:05Z chg $
 *
 */

package dk.rsd.dcc;

import dk.rsd.dcc.dispatch.Dispatcher;
import dk.rsd.dcc.dispatch.DispatcherFactory;
import dk.rsd.dcc.fault.DccFault;

import java.io.InputStream;

/**
 * Created by chg on 04/08/15.
 */
public class MockDispatcherFactory implements DispatcherFactory {

    private final InputStream responseAsStream;
    private final String responseContentType;
    private DccContext context;

    public MockDispatcherFactory(InputStream responseAsStream, String responseContentType) {
        this.responseAsStream = responseAsStream;
        this.responseContentType = responseContentType;
    }

    public Dispatcher createDispatcher() {
        return new Dispatcher() {
            public InputStream dispatch(DccContext context) throws DccFault {
                MockDispatcherFactory.this.context = context;
                context.setResponseStatusCode(200);
                context.setResponseContentType(responseContentType);
                return responseAsStream;
            }
        };
    }

    public DccContext getLastDccContext() {
        return context;
    }
}
