/*
 * SOSI-DCC - Copyright (C) 2011 National Board of e-Health (NSI)
 *
 * All source code and information supplied as part of SOSI-DCC is
 * copyright to National Board of e-Health.
 *
 * The source code has been released under a dual license - meaning you can
 * use either licensed version of the library with your code.
 *
 * It is released under the Common Public License 1.0, a copy of which can
 * be found at the link below.
 * http://www.opensource.org/licenses/cpl1.0.php
 *
 * It is released under the LGPL (GNU Lesser General Public License), either
 * version 2.1 of the License, or (at your option) any later version. A copy
 * of which can be found at the link below.
 * http://www.gnu.org/copyleft/lesser.html
 *
 * $HeadURL: https://svn.nspop.dk/svn/lakeside/sosi-dcc/tags/release-2.4.3/modules/dcc/src/test/java/dk/rsd/dcc/client/AbstractDccTestSuite.java $
 * $Id: AbstractDccTestSuite.java 33 2017-01-12 16:52:05Z chg $
 */
package dk.rsd.dcc.client;

import junit.framework.TestCase;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.Level;
import org.apache.log4j.PatternLayout;

import dk.sosi.www._2007._07.decoupling_component_1_0_xsd.DccFacadeServiceStub;

public abstract class AbstractDccTestSuite extends TestCase {

	static {
		PatternLayout patternLayout = new PatternLayout("%-5p %c - %m%n");
		ConsoleAppender consoleAppender = new ConsoleAppender(patternLayout);
		consoleAppender.setThreshold(Level.ERROR);
		BasicConfigurator.configure(consoleAppender);
	}

	protected static final String CPR = "1111111118";

	protected DccFacadeServiceStub facade;

	//private final String endpoint = System.getProperty("dcc.endpoint", "http://192.168.114.128:9081/decoupling/");
	//private final String endpoint = System.getProperty("dcc.endpoint", "http://192.168.10.60:8080/decoupling/");
	//private final String endpoint = System.getProperty("dcc.endpoint", "http://83.97.103.206:8080/decoupling/");
	private final String endpoint = System.getProperty("dcc.endpoint", "http://localhost:8080/decoupling/");

	public AbstractDccTestSuite(JMSHelper jmsHelper) {
	}

	protected void setUp() throws Exception {
		super.setUp();
		facade = new DccFacadeServiceStub(endpoint);
	}

	protected void tearDown() throws Exception {
		facade = null;
		super.tearDown();
	}


}
