package dk.rsd.dcc.client;

import dk.dkma.medicinecard.xml_schema._2009._01._01.MedicineCardRequestStructureType;
import dk.dkma.medicinecard.xml_schema._2009._01._01.MedicineCardResponseType;
import dk.dkma.medicinecard.xml_schema._2009._01._01.NewMedicineCardResponseStructureType;
import dk.sosi.www.dcc.medicinecard._2009._01._01.DGWSFault;
import dk.sosi.www.dcc.medicinecard._2009._01._01.DccMedicineCardStub;
import junit.framework.TestCase;
import org.apache.axiom.soap.SOAPFault;
import org.apache.axis2.AxisFault;
import org.apache.axis2.client.Options;
import org.apache.axis2.context.MessageContext;
import org.apache.axis2.transport.http.HTTPConstants;
import org.apache.axis2.wsdl.WSDLConstants;
import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.Level;
import org.apache.log4j.PatternLayout;

import java.rmi.RemoteException;

public class FMK12TestClient extends TestCase {

	private static final String ENDPOINT = "http://localhost:8080/decoupling/";
	//private static final String ENDPOINT = "http://trifork.lms.trifork.com/stub12/ws/MedicineCard";
	//private static final String ENDPOINT = "http://trifork.lms.trifork.com/fmk12/ws/MedicineCard";
	//private static final String ENDPOINT = "http://triforkprod.lms.trifork.com/fmk12/ws/MedicineCard";
	//private static final String ENDPOINT = "http://triforkprodtest.lms.trifork.com/fmk12/ws/MedicineCard";
	//private static final String ENDPOINT = "http://83.97.103.206:8080/decoupling/";

	//private static final String CPR = "1111111118";
	private static final String CPR = "0812926632";

	private DccMedicineCardStub facade;

	protected void setUp() throws Exception {
		super.setUp();

		PatternLayout patternLayout = new PatternLayout("%-5p %c - %m%n");
		ConsoleAppender consoleAppender = new ConsoleAppender(patternLayout);
		consoleAppender.setThreshold(Level.INFO);
		BasicConfigurator.configure(consoleAppender);

		facade = new DccMedicineCardStub(ENDPOINT);
		Options options = facade._getServiceClient().getOptions();
		options.setProperty(HTTPConstants.SO_TIMEOUT, new Integer(60 * 1000));
	}

	public void testCall() throws AxisFault {
		try {
			MedicineCardRequestStructureType medicineCardRequestStructureType = new MedicineCardRequestStructureType();
			medicineCardRequestStructureType.setPersonCivilRegistrationIdentifier(CPR);
			MedicineCardResponseType medicineCard = facade.GetMedicineCard(medicineCardRequestStructureType, null, null, null, null);
			System.out.println(medicineCard.getMedicineCardOverviewStructure().get(0).getPatientStructure().getSimpleCPRPerson()
					.getPersonCivilRegistrationIdentifier());
			System.out.println(medicineCard.getMedicineCardOverviewStructure().get(0).getPatientStructure().getAddressPostal()
					.getPostCodeIdentifier());
			NewMedicineCardResponseStructureType newGetMedicineCard = facade.NewGetMedicineCard(medicineCardRequestStructureType, null, null, null, null);
			System.out.println(newGetMedicineCard.getNewMedicineCardOverviewStructure().get(0).getPatientStructure().getSimpleCPRPerson().getPersonCivilRegistrationIdentifier());
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (DGWSFault e) {
            MessageContext messageContext = facade._getServiceClient().getLastOperationContext().getMessageContext(WSDLConstants.MESSAGE_LABEL_IN_VALUE);
            SOAPFault soapFault = messageContext.getEnvelope().getBody().getFault();
            String faultString = soapFault.getReason().getText();
            System.out.println("DGWSFault from MedicineCard: " + e.getFaultMessage() + "/" + faultString);
		}
	}

}
