/*
 * SOSI-DCC - Copyright (C) 2011 National Board of e-Health (NSI)
 *
 * All source code and information supplied as part of SOSI-DCC is
 * copyright to its contributers.
 *
 * The source code has been released under a dual license - meaning you can
 * use either licensed version of the library with your code.
 *
 * It is released under the Common Public License 1.0, a copy of which can
 * be found at the link below.
 * http://www.opensource.org/licenses/cpl1.0.php
 *
 * It is released under the LGPL (GNU Lesser General Public License), either
 * version 2.1 of the License, or (at your option) any later version. A copy
 * of which can be found at the link below.
 * http://www.gnu.org/copyleft/lesser.html
 *
 * $HeadURL: https://svn.nspop.dk/svn/lakeside/sosi-dcc/tags/release-2.4.3/modules/dcc/src/test/java/dk/rsd/dcc/client/JBossMQHelper.java $
 * $Id: JBossMQHelper.java 33 2017-01-12 16:52:05Z chg $
 */
package dk.rsd.dcc.client;

import java.util.Properties;

import javax.jms.JMSException;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class JBossMQHelper implements JMSHelper {

	//private String jbossHostname = System.getProperty("dcc.jboss_host", "83.97.103.206");
	//private String jbossHostname = System.getProperty("dcc.jboss_host", "192.168.10.58");
	private String jbossHostname = System.getProperty("dcc.jboss_host", "localhost");
	private String jbossNamingPort = System.getProperty("dcc.jboss_naming_port", "1099");

	public QueueConnection getQueueConnection() throws JMSException, NamingException {
			Properties properties = new Properties();
			properties.put("java.naming.factory.initial", "org.jnp.interfaces.NamingContextFactory");
			properties.put("java.naming.provider.url", "jnp://" + jbossHostname + ":" + jbossNamingPort);
			properties.put("java.naming.factory.url.pkgs", "org.jboss.naming:org.jnp.interfaces");
			InitialContext initialContext = new InitialContext(properties);
			QueueConnectionFactory factory = (QueueConnectionFactory) initialContext.lookup("ConnectionFactory");
			return factory.createQueueConnection();
	}

}
